<template>
    <el-row>
        <h2>
            Тесты:
            <strong>
                {{ ParseTestsStore.correctPercent }}% ({{ ParseTestsStore.correctCount }}/{{
                    ParseTestsStore.testsCount
                }})
            </strong>
        </h2>

        <el-switch
            v-model="showOnlyErrors"
            size="large"
            active-text="Показать только ошибки"
            inactive-value="0"
            active-value="1"
        />
    </el-row>

    <el-row>
        <RulesToolbar :rules="rules" :tests="tests" />
        <el-alert
            v-if="apiErrors"
            title="Не удалось сохранить тесты: {{ Array.isArray(apiErrors) ? apiErrors.join('') : apiErrors }}"
            type="error"
            show-icon
        />
    </el-row>

    <el-table
        ref="testsTable"
        :data="storeTest"
        style="width: calc(100vw - 4rem)"
        :row-class-name="rowClass"
        table-layout="auto"
        height="calc(100vh - 325px)"
        flexible
        scrollbar-always-on
    >
        <el-table-column fixed type="index" width="25" class-name="bg_transparent" />
        <el-table-column fixed label="Тест" width="350" class-name="is-wrappable bg_transparent">
            <template #default="{ row }">
                <template v-if="row.type === 'name'">{{ row.data.name }}</template>
                <template v-else>{{ JSON.stringify(row.data) }}</template>
            </template>
        </el-table-column>
        <el-table-column fixed width="95" class-name="bg_transparent">
            <template #default="scope">
                <a href="#" title="Редактировать" class="g-actionicon" @click="() => openTestEdit(scope.$index)">
                    <font-awesome-icon icon="cog" />
                </a>
                <a href="#" title="Удалить" class="g-actionicon" @click="deleteTest(scope.$index)">
                    <font-awesome-icon icon="trash" />
                </a>
            </template>
        </el-table-column>

        <el-table-column
            v-for="extraKey of keys"
            :key="extraKey"
            :label="extraKey"
            :min-width="colWidth(extraKey)"
            :show-overflow-tooltip="true"
        >
            <template #default="scope">
                <div
                    v-if="
                        ParseTestsStore.errors[scope.$index] &&
                        actual(scope.$index)[extraKey] + '' !== scope.row.expected[extraKey] + ''
                    "
                    class="value_wrong"
                >
                    {{ actual(scope.$index)[extraKey] ?? "—" }}
                </div>
                <div class="value_correct">
                    {{ scope.row.expected[extraKey] ?? "—" }}
                </div>
            </template>
        </el-table-column>
    </el-table>
    <el-button @click="addNewTest">Добавить тест</el-button>

    <TestForm
        :id="formId"
        v-model="formValues"
        :is-visible="isEditing"
        :params="params"
        @save="saveForm"
        @close="isEditing = false"
    />
</template>

<script>
import { router } from "@inertiajs/vue3";
import RulesToolbar from "@/views/pages/ParseRules/RulesToolbar.vue";
import TestForm from "@/views/pages/ParseTests/TestForm.vue";
import { useParseTestsStore } from "@/js/stores/TestsStore";
import { computed, nextTick, onMounted, ref } from "vue";

export default {
    components: { RulesToolbar, TestForm },
    props: {
        tests: {
            type: Object,
            required: true,
        },
        params: {
            type: Object,
            required: true,
        },
        errors: {
            type: Object,
            required: true,
        },
        rules: Object,
        productType: String,
        formDefaults: {
            type: Object,
            default() {
                return {
                    type: "name",
                    data: "",
                    expected: "",
                };
            },
        },
    },
    setup(props) {
        const ParseTestsStore = useParseTestsStore();
        // eslint-disable-next-line vue/no-setup-props-destructure
        ParseTestsStore.tests = props.tests;
        const testsTable = ref(null);
        ParseTestsStore.tableScroll;

        onMounted(() => {
            testsTable.value.scrollBarRef.wrapRef.onscroll = (event) => {
                if (event.target.scrollLeft !== undefined && event.target.scrollTop !== undefined)
                    ParseTestsStore.tableScroll = [event.target.scrollLeft, event.target.scrollTop];
            };
        });

        setTimeout(() => testsTable.value.scrollTo(...ParseTestsStore.tableScroll), 50);

        return {
            ParseTestsStore,
            testsTable,
            storeTest: computed(() => ParseTestsStore.tests),
        };
    },
    emits: ["onEdit", "onCreate", "onUpdate", "onDelete"],
    data() {
        return {
            showOnlyErrors: false,
            isEditing: false,
            formId: null,
            formValues: {},
            hasJsonError: false,
            apiErrors: null,
        };
    },
    computed: {
        // Заголовки распознаваемых полей
        keys() {
            return [
                "vendor",
                "model",
                ...this.params.map((param) => param.slug).filter((key) => key !== "vendor" && key !== "model"),
            ];
        },
    },
    methods: {
        addNewTest() {
            this.formId = null;
            this.formValues = { ...this.formDefaults };
            this.isEditing = true;
        },
        openTestEdit(id) {
            if (this.tests[id] === undefined) return;
            this.formId = id;
            this.formValues = this.tests[id];
            this.isEditing = true;
        },
        saveForm(id, values) {
            router.visit("/parse_tests/" + this.productType, {
                method: id === null ? "post" : "put",
                data: values,
                preserveState: true,
                preserveScroll: true,
                onError: (errors) => {
                    console.error(errors);
                    this.apiErrors = errors;
                },
                onFinish: () => {
                    this.isEditing = false;
                    const tmpTests = this.tests;
                    this.ParseTestsStore.$patch((state) => {
                        state.tests = tmpTests;
                        state.hasChanged = true;
                        this.ParseTestsStore.execTests();
                    });
                    if (!id) {
                        nextTick(() => this.testsTable.scrollTo(0, 99999));
                    }
                },
            });
        },
        deleteTest(id) {
            if (this.tests[id] === undefined) return;

            // todo preloader
            router.visit("/parse_tests/" + this.productType, {
                method: "DELETE",
                data: { id: this.tests[id].id },
                preserveScroll: true,
                onError: function (errors) {
                    //todo
                    console.log(errors);
                    this.apiErrors = errors;
                }.bind(this, id),
            });
        },
        actual(testId) {
            // TODO Вот это прям в корне неверно — нужно 1 раз получать эти данные на этапе mount-события компонента, подставлять как стартовое значение в errors-объект, а не получать из Storage и не парсить JSON при каждом точечном получении — это слишком ресурсоемко
            if (this.ParseTestsStore.errors === null) return {};
            const error = this.ParseTestsStore.errors[testId];
            if (!error) return {};

            try {
                return typeof error === "string" ? JSON.parse(error || "{}") : error;
            } catch (e) {
                return {};
            }
        },
        rowClass(rowObj) {
            return this.ParseTestsStore.errors && this.ParseTestsStore.errors[rowObj.rowIndex] ? "has-error" : "";
        },
        colWidth(colName) {
            if (colName === "vendor") return 120;

            if (colName === "model") return 180;

            return 120;
        },
    },
};
</script>

<style lang="scss" scoped>
.edit-test {
}

.el-row h2 {
    margin: 2px 20px 10px 0;
}

.el-alert {
    margin: 20px 0 0;
}

.el-alert:first-child {
    margin: 0;
}

.value_correct {
    color: darkgreen;
}

.has-error {
    .value_wrong {
        color: darkred;
        font-weight: bold;
    }

    .value_wrong + .value_correct {
        text-decoration: line-through;
    }
}
</style>

<style lang="scss">
.el-table tr {
    th,
    td,
    div {
        &:not(.is-wrappable) div {
            white-space: nowrap;
            text-overflow: ellipsis;
        }
    }
}

.b-main .b-section-h {
    padding-bottom: 0;
}

tr.has-error {
    background-color: #ffeeee !important;

    td.el-table-fixed-column--left {
        background-color: #ffeeee;
    }
}
</style>
